package de.hsel.spm.baudas.web;

import com.google.gson.Gson;
import org.jetbrains.annotations.NotNull;

import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.PrintWriter;
import java.nio.charset.StandardCharsets;

/**
 * list all currently available datasets.
 *
 * @author Johannes Theiner
 * @version 0.1
 * @since 1.0
 **/

@WebServlet("/datasets")
public class DatasetsServlet extends HttpServlet {

    private static final long serialVersionUID = 148451844848L;


    /**
     * returns all available datasets for session.
     *
     * @param req  request object
     * @param resp response object
     * @throws IOException failed to initialize print writer
     */
    @Override
    protected void doGet(@NotNull HttpServletRequest req, @NotNull HttpServletResponse resp)
            throws IOException {
        resp.setContentType("application/json");
        resp.setCharacterEncoding(StandardCharsets.UTF_8.name());
        PrintWriter out = resp.getWriter();
        Gson gson = new Gson();
        out.print(gson.toJson(DatasetManagement.getFiles().get(req.getSession().getId())));
    }
}