package de.hsel.spm.baudas.web;

import org.jetbrains.annotations.NotNull;

import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;

/**
 * logs out user if they request this.
 *
 * @author Edgar Schkrob
 * @version 0.1
 * @since 1.0
 */

@WebServlet("/logout")
public class LogoutServlet extends HttpServlet {

    /**
     * if this servlet is request logout the user.
     *
     * @param request request object
     * @param response response object
     * @throws IOException failed to initialize print writer
     */
    @Override
    protected void doGet(@NotNull HttpServletRequest request, @NotNull HttpServletResponse response) throws IOException {
        HttpSession session = request.getSession();
        if (session != null) {
            DatasetManagement.delete(session.getId());
            session.invalidate();
        }
        response.sendRedirect(request.getContextPath() + "/");
    }
}
