/**
 * renders cluster analysis results as a table.
 *
 * @author Julian Hinxlage
 * @version 0.1
 * @since 1.0
 */

let cluster_result;

function updateClusters(id) {
    if (typeof id !== 'undefined') {
        request('clusters', id).then(function (data) {
            cluster_result = data;
            drawClusterTable();
        });
    } else request('clusters').then(function (data) {
        cluster_result = data;
        drawClusterTable();
    });
}

function drawClusterTable() {
    let table = document.getElementById("cluster_table");
    while (table.hasChildNodes()) {
        table.removeChild(table.firstChild);
    }

    let row = $("<thead>");
    row.append("<tr>");
    row.append("<td></td>");
    for (let x in cluster_result) {
        if (x == 0) {
            row.append("<td>" + "Durchschnitt" + "</td>");
        } else {
            row.append("<td>" + x + "</td>");
        }
    }
    row.append("</tr>");
    row.append("</thead>");


    appendClusterTable(row, "Alter");
    appendClusterTable(row, "Wohnort");
    appendClusterTable(row, "Einkaufstag");
    appendClusterTable(row, "Geschlecht");
    appendClusterTable(row, "Familienstand");
    appendClusterTable(row, "Einkaufsuhrzeit");


    row.append("</tbody>");
    $("#cluster_table").append(row);
}

function appendClusterTable(row, attrib) {
    row.append("</tbody>");
    row.append("<tr>");
    row.append("<td>" + attrib + "</td>");
    for (let x in cluster_result) {
        row.append($("<td>" + cluster_result[x][attrib] + "</td>"));
    }
    row.append("</tr>");
}
