/**
 * renders shopping cart analysis results as a table.
 *
 * @author Karsten Eden
 * @version 0.1
 * @since 1.0
 */

let shopping_cart_result;

function updateShoppingCartTable(id) {
    if(typeof id !== 'undefined') {
        request('shopping_cart', id).then(function (data) {
            shopping_cart_result = data;
            drawShoppingCartTable();
        });
    }else request('shopping_cart_result').then(function(data) {
        shopping_cart_result = data;
        drawShoppingCartTable();
    });
}

function drawShoppingCartTable(){
    let table = document.getElementById("shopping_cart_table");
    while(table.hasChildNodes()){
        table.removeChild(table.firstChild);
    }

    let row = $("<thead>");
    row.append("<tr>");
    row.append("<th>Artikel</th>");
    row.append("<th>Wird häufig zusammen gekauft mit</th>")
    row.append("</tr>");
    row.append("</thead>");
    row.append("<tbody>");
    for (let x in shopping_cart_result){
        row.append("<tr>");
        row.append("<td>" + shopping_cart_result[x].key + "</td>");
        row.append("<td>" + shopping_cart_result[x].value + "</td>");
        row.append("</tr>");
    }
    row.append("</tbody>");
    $("#shopping_cart_table").append(row);
}

