package de.hsel.spm.baudas.analysis;

import org.junit.jupiter.api.Test;

import java.io.File;
import java.net.URL;
import java.util.Map;

import static org.junit.jupiter.api.Assertions.assertEquals;

public class TopFlopArticlesTest {

    @Test
    void test100() {
        URL url = getClass().getClassLoader().getResource("kd100.csv");
        assert url != null;
        SalesNumbers tfArticle = new SalesNumbers(new File(url.getFile()));
        Map<String, Integer> results = tfArticle.getResult();

        assertEquals(529, results.get("Farben"));
        assertEquals(2403, results.get("Elektrowerkzeuge"));
        assertEquals(8055, results.get("Baustoffe"));
        assertEquals(5414, results.get("Fliesen"));
        assertEquals(1466, results.get("Holz"));

    }

    @Test
    void test1000() {
        URL url = getClass().getClassLoader().getResource("kd1000.csv");
        assert url != null;
        SalesNumbers tfArticle = new SalesNumbers(new File(url.getFile()));
        Map<String, Integer> results = tfArticle.getResult();

        assertEquals(5643, results.get("Eisenwaren"));
        assertEquals(9339, results.get("Bodenbelag"));
        assertEquals(12824, results.get("Gartengeraete"));
        assertEquals(29055, results.get("Sanitaermaterial"));
        assertEquals(50067, results.get("Armaturen"));

    }

    @Test
    void test10000() {
        URL url = getClass().getClassLoader().getResource("kd10000.csv");
        assert url != null;
        SalesNumbers tfArticle = new SalesNumbers(new File(url.getFile()));
        Map<String, Integer> results = tfArticle.getResult();

        assertEquals(101665, results.get("Handwerkzeuge"));
        assertEquals(151920, results.get("Leuchten"));
        assertEquals(231881, results.get("Schliesstechnik"));
        assertEquals(294053, results.get("Elektromaterial"));
        assertEquals(543613, results.get("Renovierung"));

    }
}
